// CD 11/2005
// survbatt.c
// N = (AN0/VDD)*1024
// Calculs pour VDD = 5v
// allumage PBO si AN0 = 4,9v soit N0 = 1003
//			PB1 si AN0 = 4,8v soit N1 = 983
//          PB2 si AN0 = 4,7v soit N2 = 962
//          PB3 si AN0 = 4,6v soit N3 = 942
#include <p18f452.h>

#define N0 1003
#define N1 983
#define N2 962
#define N3 942
#define S2 PORTAbits.RA4

unsigned int mesVDD(void)
{
	ADCON0bits.GO_DONE=1;		// SOC sur AN0
	while(ADCON0bits.GO_DONE);	// attend EOC
	return (ADRES);
}

void main(void)
{
unsigned int mes;
		ADCON0=1;		// CAN on. CLOCK=FOSC/2. CANAL0 (RA)
    	ADCON1=0x8E;
		TRISB=0xF0;		// PRB0-PRB3 en sortie
		PORTB=0;		// LED eteintent
		TRISA=0xFF;		// PORTA en entree
		while(1)
				{
					mes=mesVDD();
					if (mes<N0) PORTBbits.RB0=1;
					if (mes<N1) PORTBbits.RB1=1;
					if (mes<N2) PORTBbits.RB2=1;
					if (mes<N3) PORTBbits.RB3=1;
					if (!S2) PORTB=0;		// eteind les LEDs
				}
}
